//
//  QCJ.java
//  QCJ
//
//  Created by Dustin O'Connor on 1/16/11.
//  Copyright (c) 2011 umaine. All rights reserved.
//
//	For information on setting Java configuration information, including 
//	setting Java properties, refer to the documentation at
//		http://developer.apple.com/techpubs/java/java.html
//

package com.example;

import javax.swing.SwingUtilities;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.File;

/**
 * Starting point for the application. General initialization should be done inside
 * the ApplicationController's init() method. If certain kinds of non-Swing initialization
 * takes too long, it should happen in a new Thread and off the Swing event dispatch thread (EDT).
 * 
 * @author d0cut0uch
 */


public class QCJ extends com.apple.eawt.CocoaComponent {
	
	static {
		System.loadLibrary("JavaQCView");
	}
	

	// Instantiate the NSView on the native side and return it as a long
	public native long createNSViewLong();
	
	// Deprecated; just cast the correct createNSViewLong implementation
	public int createNSView() {
		return (int)createNSViewLong();
	}
	

	/*
	 *  Implementation of CocoaComponent abstracts
	 */
	
	
	final static Dimension MIN_SIZE		= new Dimension(200, 200);
	final static Dimension PREF_SIZE	= new Dimension(400, 400);
	final static Dimension MAX_SIZE		= new Dimension(600, 600);
	
	public Dimension getPreferredSize() {
		return PREF_SIZE;
	}
	
	public Dimension getMinimumSize () {
		return MIN_SIZE;
	}
	
	public Dimension getMaximumSize() {
		return MAX_SIZE;
	}
	
	
	public static void main(String[] args) {	
		// Turn off CocoaComponent compatibility in the code to save time on stage
		System.setProperty("com.apple.eawt.CocoaComponent.CompatibilityMode", "false");
		
		JFrame jf = new JFrame("JavaQCView");
		
		final QCJ view = new QCJ();
		jf.getContentPane().setLayout(new BorderLayout());
		jf.getContentPane().add(view);
		jf.setResizable(false);
		jf.pack();
		jf.setVisible(true);
	}
}